;===========================================
; eeprom.asm 		
; EEPROM Read/Write function of 24c01 ~ 16
; YC
;===========================================
; Revision History
; Version	Date		Author	Description
; 0.1		2008-10-10	YC	
; 0.2		2010-2-25 	YC	޸ȫI2CЭ
;-------------------------------------------

	
;-------------------------------------------
; macro	define 
;-------------------------------------------
	
scl_out	macro
	bsf EE_SCL_PORTEN,EE_SCL
	endm

sda_pu	macro
	bsf EE_SDA_PORTPU,EE_SDA ;+Ϊ 
	endm
sda_in	macro
	bcf EE_SDA_PORTEN,EE_SDA ;+Ϊ
	endm

sda_out	macro
	bsf EE_SDA_PORTEN,EE_SDA ;+Ϊ
	endm

sda_out0	macro
	bcf EE_SDA_PORT,EE_SDA ;+0
	endm
	
scl_0	macro
	call	f_scl_0
	endm

scl_1	macro
	call	f_scl_1
	endm
	
sda_0	macro
	call	f_sda_0
	endm

sda_1	macro
	call	f_sda_1
	endm
	
skip_sda_0	macro
	btsz EE_SDA_PORT,EE_SDA
	endm
	
f_scl_0:
	bcf EE_SCL_PORT,EE_SCL
	jmp	f_ee_delay
f_scl_1:
	bsf EE_SCL_PORT,EE_SCL
	jmp	f_ee_delay
f_sda_0:
	sda_out
	jmp	f_ee_delay
f_sda_1:
	sda_in
	jmp	f_ee_delay
f_ee_delay:
;	nop ;ɸָڵʱ
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	ret				

;======================================
;޸
;======================================
;--------------------------------------
; Const Define 
;--------------------------------------
C_CHIP_CODE	equ	0a0H
C_EE_READ	equ	1
C_EE_WRITE	equ	0

;----------------------------------------
send_1	macro
	scl_0
	sda_1
	scl_1
	endm
master_no_ack	macro
	send_1
	endm

send_0	macro
	scl_0
	sda_0
	scl_1
	endm
master_ack	macro
	send_0
	endm
	
start_bit:
	scl_0
	sda_1
	scl_1
	sda_0
	ret

stop_bit:
	scl_0
	sda_0
	scl_1
	sda_1
	ret

test_ack:
	scl_0
	sda_in
	scl_1
	
	skip_sda_0
	retl	0ffh ;no ack
	retl	0
	
;-------------------------------------------------------
;i2c ʼ
;-------------------------------------------------------
ee_init:
	scl_out
	scl_1

	sda_out0
	sda_pu
	sda_in
	
	ret	
;-------------------------------------------------------
;1ֽ
;->wreg
;-------------------------------------------------------
Send_byte:
	mvf	R_ee_tmp0,1
	bsf	status,C
Send_byte_lp:
	rlfc	R_ee_tmp0,1

	btsz	status,c	
	jmp	send_byte1
		
send_byte0:	
	send_0
	jmp	send_byte_com	
send_byte1:
	send_1
send_byte_com:
	bcf	status,C
	rlfc	R_ee_tmp0,0
	bcf	status,C
	jnz	Send_byte_lp
	
	ret

;-------------------------------------------------------
;1ֽ
;->wreg
;-------------------------------------------------------
get_byte:
	mvl	8
	mvf	R_ee_tmp0,1
get_byte_lp:
	scl_0
	sda_in
	scl_1
	
	rlfc	wreg,1
	
	bcf	wreg,0
	skip_sda_0
	bsf	wreg,0
	


	dcsz	R_ee_tmp0,1
	jmp	get_byte_lp
	ret
	
;--------------------------------------------------------
;ȡ
; EEPROMַ->ee_addr  RAMʼַ->fsr0L  n->wreg n>0
;--------------------------------------------------------
s_ee_read01:
s_ee_read02:
	clrf	R_ee_addrh
 ;wregݲ
ee_read_block:
	mvf	R_ee_cnt,1 ;ȡn>0
	
ee_read_block1: ;R_ee_cntݲ
	call	ee_init
	call	start_bit

	rlfc	R_ee_addrh,0
	andl	00001110b 
	addl	C_CHIP_CODE+C_EE_WRITE
	call	send_byte

	call	test_ack
	btsz	wreg,0
	jmp ee_error

	mvf	R_ee_addrl,0
	call	send_byte

	call	test_ack
	btsz	wreg,0
	jmp ee_error
	
read_block_next:
	call	start_bit
	rlfc	R_ee_addrh,0
	andl	00001110b
	addl	C_CHIP_CODE+C_EE_READ	;־λ
	call	send_byte
	
	call	test_ack
	btsz	wreg,0
	jmp ee_error
	
read_block_next2:
	call	get_byte
	mvf	indf0,1
	dcsz	R_ee_cnt,1
	jmp	read_block_next1

	master_no_ack
	jmp	ee_done
read_block_next1:
	inf	fsr0L,1
	master_ack
	jmp	read_block_next2
;--------------------------------------------------------
;д
; EEPROMַ->ee_addr  RAMʼַ->fsr0L  n->wreg
;--------------------------------------------------------
s_ee_write01:
s_ee_write02:
	clrf	R_ee_addrh
 ;wregݲ	
ee_write_block:
	mvf	R_ee_cnt,1 ;д
	
;R_ee_cntݲ
ee_write_block1:
	EE_WP_OFF
	call	ee_init
	call	start_bit
	
	rlfc	R_ee_addrh,0
	andl	00001110b 
	addl	C_CHIP_CODE+C_EE_WRITE
	call	send_byte

	call	test_ack
	btsz	wreg,0
	 jmp ee_w_error

	mvf	R_ee_addrl,0
	call	send_byte

	call	test_ack
	btsz	wreg,0
	jmp ee_w_error
	
write_block_lp:	
	mvf	indf0,0
	call	send_byte
	
	call	test_ack
	btsz	wreg,0
	jmp	ee_w_error
	
	inf	fsr0L,1

	dcsz	R_ee_cnt,1
	jmp	write_block_lp

ee_done: ;дɹ
	call	stop_bit
	EE_WP_ON
	retl	C_EE_DONE
	
;------------------------------------
; eeд 
;-------------------------------------
ee_w_error:
	EE_WP_ON
ee_error:
	ee_rw_error
	call	stop_bit
	retl	C_EE_ERROR	
	
;===========================================
; eeprom.asm 		
; EEPROM Read/Write function of 24c01 ~ 16
; YC
;===========================================
;*******************************************************	
Delay10ms:
        mvl     80
        mvf     temr,F,ACCE
     Delay10ms_2:   
        mvl     0
     Delay10ms_1:   
        dcsz    WREG,F,ACCE
        jmp     Delay10ms_1
        dcsz    temr,F,ACCE
        jmp     Delay10ms_2
        ret   

